
printf("**** Loading: %s\n", File.basename(__FILE__))

#require 'Win32API' # for Registry functions

# this trace is in case anyone calls one from outside all classes
def trace(*args)
	begin
		smess = sprintf(*args)
		#puts 'TRACE: ' + smess	# always output argument
		#if ($rpwalls)
		#	scall = caller[0].to_s # who called the routine
		#	$rpwalls.dll_call_do_trace(smess, scall)
		#	return
		#else		
			puts smess	# always output argument
		#end#if	
		return
	rescue
		warn "arg ERROR IN trace called from: " + caller(1)[0].to_s
	end	
end

# show error message with trace back
# uses sprintf() formatting
def do_error(*args)
	scall = caller[0].to_s # who called the error routine
	$call = caller
	$scall = scall
	smess = "DO_ERROR";
	begin
		smess = sprintf(*args)
	rescue
		warn "arg ERROR IN do_error called from: " + scall
	end	
	p smess + "\n"
	UI.messagebox (smess + "\n\t(" + scall + ")")
end#def	


#IRender stores Float functions in _base.rb

class Float
	## convert to two longs to send to Win32API
	def to_ll
		[self].pack("D").unpack("LL")
	end#def
end#class Float
def to_ll(fval)
	fval.to_f.to_ll
end#def

# make these send 0 and 1 to dll	
class FalseClass; 	def to_i; 	return(0); 	end end
class TrueClass; 	def to_i; 	return(1); 	end end

class String
	# define our special functions for String
	def Left(ilen)
		return("") if (ilen <= 0)		
		ilen = self.length if (ilen > self.length)
		sret = self.slice( 0, ilen )
		#trace("Left: '%s' ilen: %s sret: '%s'",self, ilen, sret)
		return sret
	end#def Left
	# ilen characters starting at ipos (0 = first)
	# if ilen is not specified, return all characters
	def Mid(ipos, ilen = nil)

		# returns a blank string, rather than nil if too large
		return("") if (ipos >= self.length)
		return("") if (ipos < 0)
		
		ilen = self.length - ipos if (ilen == nil)
		ilen = self.length - ipos if (ipos + ilen > self.length)
		return("") if (ipos <= 0)
	
		sret = sret = self.slice( ipos, ipos + ilen - 1 )
		#trace("Mid: '%s' ipos: %s ilen: %s sret: '%s'",self, ipos, ilen, sret)
		return sret
	end
	def Right(ilen)
		# returns a blank string, rather than nil if too small
		return("") if (ilen < 0)
		ilen = self.length if (ilen > self.length)		
	
		sret = sret = self.slice(self.length-ilen , self.length )
		#trace("Mid: '%s' ilen: %s sret: '%s'",self, ilen, sret)
		return sret
	end#def Right


	# Return the portion of the string up to the first NULL character.  This
	# was added for both speed and convenience.
	def nstrip
		self[ /^[^\0]*/ ]
	end#def
	def Find(str, istart = 0)
		ipos = self.index(str,istart)
		ipos = -1 if ipos == nil
		#trace("'%s' str: '%s' ipos: %s",self,str,ipos)
		return ipos
	end#def
	def ReverseFind(str, iend = nil)
		if (iend)
			ipos = self.rindex(str,iend)
		else
			ipos = self.rindex(str)
		end#if
		ipos = -1 if ipos == nil
		#trace("'%s' str: '%s' ipos: %s",self,str,ipos)
		return ipos
	end#def
	
end#class String

	if (!defined?(HKEY_CURRENT_USER))
		#trace("defining functions")
		HKEY_CURRENT_USER  = 0x80000001 
		HKEY_LOCAL_MACHINE = 0x80000002
		KEY_READ   = 0x20019
		#KEY_WRITE = 0x20006
	end#if

class RpWalls
	
	# display the call stack
	def show_stack(name = "")
		$traceback = sprintf("TRACEBACK: %s\n",name)
		calls = caller(1)
		calls.each do |caller|
			$traceback = $traceback + sprintf("     called by: %s\n",caller)
		end
		puts $traceback
	end

	# no registry functions
	
end#class RpWalls

#standard folder for release version

path = Sketchup.find_support_file("Plugins/RpWalls")

$rpwalls_release_folder = path
# also debug for now
$rpwalls_debug_folder = File.expand_path('c:/devc_2005/RpWalls/rp_debug') # .rb and appl location for debug version

$rpwalls_is_debug = false

printf("$rpwalls_release_folder: %s\n", $rpwalls_release_folder)
printf("$rpwalls_debug_folder: %s\n",$rpwalls_debug_folder)

require 'LangHandler.rb'

$RpWalls_Strings = LanguageHandler.new("RpWalls")

srpwalls_base_file_debug = $rpwalls_debug_folder.to_s +  '/ruby/Rpwalls_base.rb'
srpwalls_base_file_release = $rpwalls_release_folder.to_s +  '/ruby/Rpwalls_base.rbs'

printf("srpwalls_base_file_debug: %s\n",srpwalls_base_file_debug)
printf("srpwalls_base_file_debug: Exists: %s\n", FileTest.exist?( srpwalls_base_file_debug))

begin
	if (FileTest.exist?( srpwalls_base_file_debug))
		printf("Setting up for debug mode\n")
		$rps_file = srpwalls_base_file_debug
		load($rps_file)
		rpwalls_base("RpWallMaker")
	elsif (FileTest.exist?( srpwalls_base_file_release))
		$rps_file = srpwalls_base_file_release
		Sketchup.load($rps_file)
		rpwalls_base("RpWallMaker")
	else
		printf("Rpwalls_base.rb or .rbs not found\n")
	end#if
rescue Exception => $emess
	printf("ERROR loading: %s\n\t%s\n\tin: %s\n",$rps_file,$emess.message,$emess.backtrace[0])
end



	
